import pytest
from sys_core.agents.error_handling import CircuitBreaker, ServiceUnavailable

class TestCircuitBreaker:
    @pytest.mark.asyncio
    async def test_circuit_opens_after_failures(self):
        cb = CircuitBreaker(max_failures=3)
        
        @cb
        async def faulty_func():
            raise ValueError("Simulated failure")
            
        # First 3 failures
        for _ in range(3):
            with pytest.raises(ValueError):
                await faulty_func()
                
        # Fourth call should trip circuit
        with pytest.raises(ServiceUnavailable):
            await faulty_func()
