import pytest
import torch
from SYS_RESEARCH.security.research_vault import HybridResearchVault

def test_hybrid_vault():
    # Create a simple model state dict
    state_dict = {
        'layer1.weight': torch.randn(10, 10),
        'layer1.bias': torch.randn(10)
    }
    
    # Initialize vault
    vault = HybridResearchVault()
    
    # Test save and load
    vault.save_model(state_dict, 'test_model', use_aes=True)
    loaded_state = vault.load_model('test_model', use_aes=True)
    
    # Verify loaded state
    assert isinstance(loaded_state, dict)
    assert 'layer1.weight' in loaded_state
    assert 'layer1.bias' in loaded_state
