import pytest
from SYS_RESEARCH.security.research_vault import ResearchVault

@pytest.mark.asyncio
async def test_hmac_integrity():
    vault = ResearchVault()
    sig1 = vault.sign_request({'test': 'data'})
    sig2 = vault.sign_request({'test': 'data'})
    assert sig1 != sig2  # Unique knowledge_graph_id per call

@pytest.mark.asyncio
async def test_key_rotation_purge():
    vault = ResearchVault()
    vault.rotate_key('test_service')
    assert 'previous' in vault.key_versions['test_service']
    await asyncio.sleep(0.1)  # Simulate time passage
    assert 'previous' not in vault.key_versions['test_service']
